@echo off

cls
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo       The zip extraction should have created two test directories: SRCE and DEST
echo       If it did not, quit this process (ctrl-c) and extract the data while 
echo       maintaining folder and tree while extracting the files into directories. 
echo.
echo       doing a DIR to see if they are already created:
echo       look for the DEST and SRCE directories


dir   /AD
echo.
echo.


pause
if not exist  .\SRCE\IN_SRCE_NOT_IN_DEST.htm   goto error
if not exist  .\DEST\IN_DEST_NOT_IN_SRCE.htm   goto error


cls
echo.
echo.
echo.
echo.
echo         We are about to do simple hashes of two directories (SRCE and DEST),
echo         Then use hashcmp to compare the files
pause


.\exes\hash   -p  SRCE   -d "|"  -v  -w 300 -o  SRCE_HASH_1  -R
.\exes\hash   -p  DEST   -d "|"  -v  -w 300 -o  DEST_HASH_1  -R

cls

.\exes\hashcmp   SRCE_HASH_1  DEST_HASH_1   -o  MISMATCH1 -h -x 


cls
echo.
echo. 
echo   *******************************************************
echo.
echo      hashcmp completed, and these are the mismatched items.
echo      since the records are long, they are multi-lined output
echo.

type      MISMATCH1

pause

rem   **********************************************
rem   ************************************************
:STEP2

cls
echo.
echo.
echo.
echo.
echo      Now in this version, we use the disksort/total combination 
echo      to validate there are no unusual hashes in one or the other directory
echo      we will use the existing SRCE_HASH and DEST_HASH from the prior run.
echo      remember, DEST_HASH has a single file not matching SRCE_HASH
echo      and there are two identicle files in SRCE which are not in DEST
echo.
pause

.\exes\hash   -p  SRCE   -d "|"  -v  -w 300 -o  SRCE_HASH_2  -R
.\exes\hash   -p  DEST   -d "|"  -v  -w 300 -o  DEST_HASH_2  -R


rem  presort and unique
.\exes\disksort  SRCE_HASH_2         SRCE_HASH_2.SRT -r 388 -p 311 -l 32 -u
.\exes\disksort  DEST_HASH_2         DEST_HASH_2.SRT -r 388 -p 311 -l 32 -u
copy         /b  SRCE_HASH_2.SRT  +  DEST_HASH_2.SRT      COMBINED2
.\exes\disksort  COMBINED2           COMBINED2.SRT  -r 388 -p 311 -l 32 
.\exes\total     COMBINED2.SRT       COMBINED2.CNT  -r 388 -p 311 -l 32 -c
.\exes\grep  +1  COMBINED2.CNT   >   MISMATCH2

cls
echo.                                            
echo.
echo  Here is the content of the MISMATCHED files.
echo  notice the item with the +1, meaning only THAT hash showed up
echo.
echo.
echo.
echo.
echo.
echo.

type      MISMATCH2

pause

rem ***********************************************************
:STEP3
cls

echo.
echo.
echo.
echo     This section compares two different formatted files on the same field (MD5)
echo     although both hash files are identicle, one only needs to adjust the sort 
echo     parameters based on the format of each file, and then adjust the 
echo     compare parameter file to reflect the format of each input file.
echo     the compare parameter file content is remarked here.
pause

.\exes\hash   -p  SRCE   -d "|"  -v  -w 300 -o  SRCE_HASH_3  -R
.\exes\hash   -p  DEST   -d "|"  -v  -w 300 -o  DEST_HASH_3  -R


.\exes\disksort  SRCE_HASH_3        SRCE_HASH_3.SRT -r 388 -p 310 -l 32 
.\exes\disksort  DEST_HASH_3        DEST_HASH_3.SRT -r 388 -p 310 -l 32 
.\exes\compare   SRCE_HASH_3.SRT    DEST_HASH_3.SRT  MISMATCH3  .\exes\compare.par -u


echo.
echo.
echo    Here are the mismatched (hash value) files on DEST not on SRCE

type      MISMATCH3

rem: compare parameter file contents:
rem  each line is commented
rem  5                block factor of output, just a place holder
rem  388              file A record length
rem  38800            file A block size, any multiple of record length, < 64000
rem  388              file B record length, this may be different than fileA
rem  38800            file B block size, a multiple of record length < 64000
rem  310              location of target field in file A, in this case 310 from 0
rem  310              location of target field in file B, again 310 from 0
rem  32               length of the compare field, in this case 32 for MD5
rem  B000=0388

rem                   output this item to the output file
rem                   because of -u unequal compare, ONLY B file content allowed output
rem                   in other match cases, output file is built from both A and B records
rem                   when a match is found.


goto END

:ERROR
echo it is expected that the default directory on the C: drive contains two test directories.
echo a directory named SOURCE1 and one named SOURCE2
echo.
echo they should be the default on C: and contain almost similar files to perform these tests
echo you can adjust the content of SOURCE1 and SOURCE2 as you want, to see how the programs work.
echo.
echo.
echo This batch file is a simple example, and has greater capabilities. especially the 
echo use of the compare program.



:END

