@echo off

cls
echo.
echo.
echo.
echo.
echo       The zip extraction should have created two test directories: SRCE and DEST
echo       If it did not, quit this process (ctrl-c) and extract the data from the zip 
echo       file while maintaining folder and tree structure.
echo.
echo       The two temporary directories for this demonstration
echo       they are named SRCE and DEST 
echo.
echo       If you do not see them, quit this process.
echo.

dir    /AD


pause


if not exist  SRCE\IN_SRCE_NOT_IN_DEST.htm   goto error
if not exist  DEST\IN_DEST_NOT_IN_SRCE.htm   goto error




:STEP1 
rem   set up two directories on c: drive, source1 and source2
rem   place the same files in both directories.

cls
echo.
echo.
echo.
echo.
echo.
echo.
echo         We are about to do simple hashes of two directories (SRCE and DEST),
echo         Then use hashcmp to compare the files
pause


.\exes\hash   -p  SRCE   -d "|"  -v  -w 300 -o  SRCE_HASH_1  -R
.\exes\hash   -p  DEST   -d "|"  -v  -w 300 -o  DEST_HASH_1  -R

cls

.\exes\hashcmp   SRCE_HASH_1  DEST_HASH_1   -o  MISMATCH1 -h -x 


cls
echo.
echo. 
echo   *******************************************************
echo.
echo      hashcmp completed, and these are the mismatched items.
echo      since the records are long, they are multi-lined output
echo.

type      MISMATCH1

pause
cls
echo.
echo.
echo    *******************************************************
echo.
echo  Now we will run two new hash runs on identicle files 
echo  and then run hashcmp again. you will see no errors.
echo.
echo.
pause

.\exes\hash    -p SRCE -vo    SRCE_HASH_4 -f s*.htm -w 90 -d "|"
.\exes\hash    -p DEST -vo    DEST_HASH_4 -f s*.htm -w 90 -d "|"
.\exes\hashcmp SRCE_HASH_4    DEST_HASH_4  -o MISMATCH4  -xh

echo.
echo.
echo  Notice we found 0 mismatches when the directories have the correct hash values.
echo.


goto END

:ERROR
echo.
echo.
echo It appears that the DEST and/or SRCE directories were not created and populated
echo please determine what was wrong and fix the problem
echo.
echo.

:END






